#include <iostream>
#include <string>
#include <cstring>
#include <ctime>


#include <ncurses.h>
#include <cstdlib>

#include "TH1D.h"
#include "TFile.h"

using namespace std;

//functions
void mvwprintwcenter ( WINDOW *win, int _y, string _string );
void cleanUp() {
  endwin();
}
//globals
WINDOW *titleWin, *infoContainer;
int x, y;

int main ( int argc, char **argv ) {

  char buffer[70];
  noecho();
  initscr();
  clear();
  atexit ( cleanUp );
  start_color();

  cbreak();
  keypad ( stdscr, TRUE );
  getmaxyx ( stdscr, y, x );

  init_pair ( 1, COLOR_RED, COLOR_BLACK );
  init_pair ( 2, COLOR_WHITE, COLOR_BLUE );

  titleWin = newwin ( 10, x - 2, 1, 1 );
  box ( titleWin, 0, 0 );

  infoContainer = newwin ( y - 12, x - 2, 11, 1 );

  wbkgd ( infoContainer, COLOR_PAIR ( 2 ) );
  wcolor_set ( infoContainer, 2, 0 );

  box ( infoContainer, 0, 0 );
  mvwprintwcenter ( infoContainer, 0, "NCurses ROOT6 test" );
  mvwprintwcenter ( infoContainer, 10, "Making 10 root histos and writing them to a file this may take some seconds!" );


  refresh();
  wrefresh ( titleWin );
  wrefresh ( infoContainer );

  int infoX, infoY;


  //----------- do some root stuff
  TH1D* histos[10];
  for ( int i = 0; i < 10; i++ ) {
    sprintf ( buffer, "TestHist_%i", i );
    histos[i] = new TH1D ( buffer, buffer, 1000, 0.0, 1.0 );
  }
  TFile* myFile = new TFile ( "testRoot.root", "RECREATE" );
  for ( int i = 0; i < 10; i++ )
    histos[i]->Write();
  myFile->Flush();
  myFile->Close();
  //--------------------------------

  flash();
  sprintf ( buffer, "GENERATION FINISHED!!!! Sum of weights is...." );

  mvwprintwcenter ( infoContainer, 22, buffer );
  mvwprintwcenter ( infoContainer, 23, "Write this down, then press ESC to exit!" );

  wrefresh ( infoContainer );
  int x = 0;
  while ( x != 27 ) {
    x = getch();
  }
  clrtoeol();
  cleanUp();
  return EXIT_SUCCESS;
}

void mvwprintwcenter ( WINDOW *win, int _y, string _string ) {
  int x, y;
  getmaxyx ( win, y, x );
  mvwprintw ( win, _y, ( x - _string.length() ) / 2, _string.c_str() );
}
